local function ConnectElevators(self)
	for k = 1,8,1 do
		if self.User[k-1] ~= 0 then
			table.insert(self.Link, GetObject(self.User[k-1]))
		end
	end
	self.State = 2
end

local function ClawsOnElevator(self)
	for _,elevator in ipairs(self.Link) do
		if elevator:IsBelow(GetClaw()) then
			return true
		end
	end
	return false
end

function main(self)
	if self.State == 0 then
		self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
		self.Link = { }
		self.State = 1
	end
	-- Connect elevators:
	if self.State == 1 then
		ConnectElevators(self)
	end
	-- Check if Claw stands on one of the elevators:
	if self.State == 2 then
		if ClawsOnElevator(self) == true then
			self.State = 3
		end
		if GetClaw().X > self.XMax or GetClaw().X < self.XMin or GetClaw().Y > self.YMax or GetClaw().Y < self.YMin then
			self.State = 40
		end
	end
	-- Stop elevators:
	if self.State == 3 then
		for _,elevator in ipairs(self.Link) do
			if elevator.State ~= 0 then
				elevator.State = 201
			end
		end
		self.State = 4
	end
	-- Check if Claw doesn't stand on any elevator:
	if self.State == 4 then
		if ClawsOnElevator(self) == false then
			self.State = 5
		end
	end
	-- Start elevators:
	if self.State == 5 then
		for _,elevator in ipairs(self.Link) do
			if elevator.State ~= 0 then
				elevator.State = 1
			end
		end
		self.State = 2
	end
	-- Idle:
	if self.State == 40 then
		if GetClaw().X < self.XMax and GetClaw().X > self.XMin and GetClaw().Y < self.YMax and GetClaw().Y > self.YMin then
			self.State = 1
		end
	end
end