if not packagePathAdded then
    packagePathAdded = true
    local csPath = GetMapName():match'^(.*)%.' .. "\\LUA\\?.lua;"
    package.path = package.path .. csPath
end

local pl = require "PegLeg"


function main(self)

    local action = pl:MainPlane()

	if self.State == 0 then 
		self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
		self.Elevators = {}
		self.State = 1
	end
	if self.State == 1 then
		PlayerData().PistolAmmo, PlayerData().MagicAmmo, PlayerData().TNTAmmo = 30, 10, 10
		if GetGameType() == GameType.SinglePlayer then
			PlayerData().Lives = 9
		end
		self.State = 2
	end
	if self.State == 2 then
		-- some lava geysers:
		GetObject(2253):Destroy()
		GetObject(5489):Destroy()
		GetObject(1242):Destroy()
		GetObject(1243):Destroy()
		GetObject(1244):Destroy()
        GetObject(2200):Destroy()
        GetObject(1847):Destroy()
        GetObject(1846):Destroy()
        GetObject(4849):Destroy()
        -- other:
        GetObject(3525):Destroy()
        GetObject(3603):Destroy()
        GetObject(3604):Destroy()
        GetObject(3605):Destroy()
		-- 28000 x 13500:
		table.insert(self.Elevators, GetObject(992))
		table.insert(self.Elevators, GetObject(759))
		table.insert(self.Elevators, GetObject(993))
		table.insert(self.Elevators, GetObject(994))
		table.insert(self.Elevators, GetObject(995))
		table.insert(self.Elevators, GetObject(996))
		table.insert(self.Elevators, GetObject(997))
		table.insert(self.Elevators, GetObject(998))
		table.insert(self.Elevators, GetObject(999))
		table.insert(self.Elevators, GetObject(1000))
		table.insert(self.Elevators, GetObject(1001))
		table.insert(self.Elevators, GetObject(1002))
		-- 25000 x 13200:
		table.insert(self.Elevators, GetObject(679))
		table.insert(self.Elevators, GetObject(753))
		table.insert(self.Elevators, GetObject(754))
		table.insert(self.Elevators, GetObject(680))
		-- 24000 x 14000:
		table.insert(self.Elevators, GetObject(919))
		table.insert(self.Elevators, GetObject(921))
		table.insert(self.Elevators, GetObject(922))
		table.insert(self.Elevators, GetObject(923))
		-- 26000 x 3500:
		table.insert(self.Elevators, GetObject(5486))
		table.insert(self.Elevators, GetObject(5487))
		table.insert(self.Elevators, GetObject(5485))
		table.insert(self.Elevators, GetObject(2237))
		-- 27500 x 12000:
		table.insert(self.Elevators, GetObject(1401))
		table.insert(self.Elevators, GetObject(1402))
		table.insert(self.Elevators, GetObject(1344))
		table.insert(self.Elevators, GetObject(1345))
		table.insert(self.Elevators, GetObject(1346))
		table.insert(self.Elevators, GetObject(1343))
		-- 6900 x 10400:
		table.insert(self.Elevators, GetObject(4710))
		-- 8300 x 11400:
		table.insert(self.Elevators, GetObject(3054))
		table.insert(self.Elevators, GetObject(4510))
		table.insert(self.Elevators, GetObject(4508))
		table.insert(self.Elevators, GetObject(4509))
		table.insert(self.Elevators, GetObject(4503))
		table.insert(self.Elevators, GetObject(4507))
		table.insert(self.Elevators, GetObject(4506))
		table.insert(self.Elevators, GetObject(4505))
		-- 16000 x 5200:
		table.insert(self.Elevators, GetObject(2393))
		table.insert(self.Elevators, GetObject(2412))
		table.insert(self.Elevators, GetObject(2395))
		table.insert(self.Elevators, GetObject(2399))
		table.insert(self.Elevators, GetObject(2396))
		table.insert(self.Elevators, GetObject(2398))
		table.insert(self.Elevators, GetObject(2397))
		table.insert(self.Elevators, GetObject(2394))
		-- 14600 x 6000:
		table.insert(self.Elevators, GetObject(2231))
		table.insert(self.Elevators, GetObject(2232))
		table.insert(self.Elevators, GetObject(2240))
		table.insert(self.Elevators, GetObject(2242))
		table.insert(self.Elevators, GetObject(2230))
		table.insert(self.Elevators, GetObject(2235))
		-- 27000 x 13700:
		table.insert(self.Elevators, GetObject(656))
		table.insert(self.Elevators, GetObject(756))
		table.insert(self.Elevators, GetObject(757))
		table.insert(self.Elevators, GetObject(760))
		-- 50500 x 12000:
		table.insert(self.Elevators, GetObject(4906))
		table.insert(self.Elevators, GetObject(4907))
		-- 56300 x 11000:
		table.insert(self.Elevators, GetObject(5181))
		table.insert(self.Elevators, GetObject(5182))
		-- 9300 x 6000:
		table.insert(self.Elevators, GetObject(3299))
		table.insert(self.Elevators, GetObject(3302))
		table.insert(self.Elevators, GetObject(3300))
		self.State = 3
	end
	-- Reduce speed of elevators:
	if self.State == 3 then
		for i,elevator in ipairs(self.Elevators) do
			elevator.Speed = math.floor(0.85 * elevator.Speed) 
			elevator.SpeedY = math.floor(0.85 * elevator.SpeedY) 
			elevator.SpeedX = math.floor(0.85 * elevator.SpeedX) 
		end
		self.State = 4
	end
    -- Place/Replace some tiles:
    if self.State == 4 then
        -- single pegs:
        pl:PlaceTile(236, action, 466, 77)
        pl:PlaceTile(236, action, 474, 74)
        pl:PlaceTile(236, action, 477, 71)
        pl:PlaceTile(236, action, 480, 68)
        pl:PlaceTile(236, action, 483, 65)
        pl:PlaceTile(236, action, 486, 62)
        -- ladder:
        pl:PlaceTile(203, action, 117, 164)
        pl:PlaceTile(234, action, 403, 226)
        pl:PlaceTile(235, action, 403, 227)
        -- no spikes:
        pl:PlaceTile(-1, action, 389, 211)
        pl:PlaceTile(-1, action, 390, 211)
        pl:PlaceTile(-1, action, 391, 211)
        pl:PlaceTile(-1, action, 392, 211)
        pl:PlaceTile(-1, action, 393, 211)
        pl:PlaceTile(153, action, 389, 212)
        pl:PlaceTile(310, action, 390, 212)
        pl:PlaceTile(154, action, 391, 212)
        pl:PlaceTile(311, action, 392, 212)
        pl:PlaceTile(155, action, 393, 212)
        -- no ceiling spikes:
        pl:PlaceTile(461, action, 681, 193)
        pl:PlaceTile(-1, action, 682, 193)
        pl:PlaceTile(463, action, 683, 193)
        self.State = 5
    end

	if self.State == 5 then
		self:Destroy()
	end
end
