local function DynamiteInput()
	return AND(GetInput(),0x100) ~= 0 or (PlayerData()._unkn13 == 3 and AND(GetInput(),0x4) ~= 0)
end

local function ArrowsInput()
	local input = (string.format("%x", GetInput()))
	local sign7 = string.sub(input, -7, -7)
	if sign7 == "1" then return 4
	elseif sign7 == "2" then return 6
	elseif sign7 == "4" then return 8
	elseif sign7 == "8" then return 2
	elseif sign7 == "5" then return 7
	elseif sign7 == "6" then return 9
	elseif sign7 == "9" then return 1
	elseif sign7 == "a" then return 3
	else return 5 end
end

local function CameraVelocityX()
	if ArrowsInput() == 9 then return 5
	elseif ArrowsInput() == 6 then return 7
	elseif ArrowsInput() == 3 then return 5
	elseif ArrowsInput() == 1 then return -5
	elseif ArrowsInput() == 4 then return -7
	elseif ArrowsInput() == 7 then return -5
	else return 0 end
end

local function CameraVelocityY()
	if ArrowsInput() == 7 then return -5
	elseif ArrowsInput() == 8 then return -7
	elseif ArrowsInput() == 9 then return -5
	elseif ArrowsInput() == 3 then return 5
	elseif ArrowsInput() == 2 then return 7
	elseif ArrowsInput() == 1 then return 5
	else return 0 end
end

function main(self)

	PLAY_AREA = ffi.cast("Rect*", 0x535840)[0]
	
    if self.State == 0 then
		self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
        self.BlockTime = 0
		self.State = 1250
	end

	-- Create aim HUD element:
	if self.State == 1250 then
		local flags = ffi.new("Flags_t")
		flags.AlwaysActive = true
		self.Aim = CreateObject{x=math.floor(PLAY_AREA.Right/2)+1,y=math.floor(PLAY_AREA.Bottom/2)+1,z=10550,logic="BackgroundLogic",image="CUSTOM_METEOR_AIM", Flags=flags}
		self.Aim.DrawFlags.NoDraw = true
		self.State = 1251
	end

	-- Check for dynamite input:
	if self.State == 1251 then
		if DynamiteInput() and PlayerData().TNTAmmo > 0 and GetClaw().Health > 0 and 
        --[[&]] GetClaw().State ~= 5002 and GetClaw().State ~= 5006 and GetClaw().State ~= 5007 and GetClaw().State ~= 5005 and GetClaw().State ~= 5009 then 
			-- Unhide aim HUD:
			self.Aim.DrawFlags.NoDraw = false
			-- Save Claw's coordinates as starting point for camera:
			self.XCoord, self.YCoord = GetClaw().X, GetClaw().Y
			-- Save current Claw's State:
			self.LastClawsState = GetClaw().State
            -- Save time:
            self.BlockTime = GetTime() + 20
			-- Change state:
			self.State = 1253
		end
	end

    -- Freeze Claw:
    if self.State == 1253 then
        GetClaw().State = 5009
        self.State = 1254
    end
	

	if self.State == 1254 and GetTime() > self.BlockTime then
		-- Control camera:
		self.XCoord = self.XCoord + CameraVelocityX()
		self.YCoord = self.YCoord + CameraVelocityY()
		if self.XCoord > GetClaw().X + 640 then self.XCoord = GetClaw().X + 640 end
		if self.XCoord < GetClaw().X - 640 then self.XCoord = GetClaw().X - 640 end
		if self.YCoord > GetClaw().Y + 480 then self.YCoord = GetClaw().Y + 480 end
		if self.YCoord < GetClaw().Y - 480 then self.YCoord = GetClaw().Y - 480 end
		CameraToPoint(self.XCoord, self.YCoord)
		-- Check for dynamite input or if Claw is in the air:
		if not DynamiteInput() or self.LastClawsState == 4 or self.LastClawsState == 25 then 
			-- Create meteor, play sound and spend one TNT ammo:
			CreateObject{x=self.XCoord-500,y=self.YCoord-500,z=8800,logic="CustomLogic",name="PowerOfFireEssenceProjectile"}
			PlaySound("CUSTOM_METEOR_FALL")
			PlayerData().TNTAmmo = math.floor(PlayerData().TNTAmmo - 1)
			-- Go back to the previous state:
			GetClaw().State = self.LastClawsState
			CameraToClaw()
			self.Aim.DrawFlags.NoDraw = true
            if self.LastClawsState == 4 or self.LastClawsState == 25 then
                self.State = 1263
            else
			    self.State = 1251
            end
		end
		-- Check for Claw's health, go back to the previous state in case he dies:
		if GetClaw().Health <= 0 then
			CameraToClaw()
			self.Aim.DrawFlags.NoDraw = true
			self.State = 1251
		end
	end


    if self.State == 1263 and not DynamiteInput() then
        self.State = 1251
    end
end
