local function SpecialAttackInput()
	return AND(GetInput(),0x200) ~= 0
end

function main(self)

	PLAY_AREA = ffi.cast("Rect*", 0x535840)[0]
	
    if self.State == 0 then
		self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
		self.Cooldown = 0
		self.EmptySoundDelay = 0
		self.FireSoundDelay = 0
		self.State = 101
	end

	-- Create interface:
	if self.State == 101 then
		local flags = ffi.new("Flags_t")
		flags.AlwaysActive = true
		if GetGameType() == GameType.MultiPlayer then
			self.Interface = CreateObject{x=PLAY_AREA.Right-23,y=72,z=10050,logic="BackgroundLogic",image="CUSTOM_INTERFACE_FS", Flags=flags}
			self.SmallNumber1 = CreateObject{x=PLAY_AREA.Right-39,y=73,z=10050,logic="BackgroundLogic",image="GAME_INTERFACE_SMALLNUMBERS", Flags=flags}
			self.SmallNumber2 = CreateObject{x=PLAY_AREA.Right-31,y=73,z=10050,logic="BackgroundLogic",image="GAME_INTERFACE_SMALLNUMBERS", Flags=flags}
		else
			self.Interface = CreateObject{x=PLAY_AREA.Right-23,y=98,z=10050,logic="BackgroundLogic",image="CUSTOM_INTERFACE_FS", Flags=flags}
			self.SmallNumber1 = CreateObject{x=PLAY_AREA.Right-39,y=99,z=10050,logic="BackgroundLogic",image="GAME_INTERFACE_SMALLNUMBERS", Flags=flags}
			self.SmallNumber2 = CreateObject{x=PLAY_AREA.Right-31,y=99,z=10050,logic="BackgroundLogic",image="GAME_INTERFACE_SMALLNUMBERS", Flags=flags}
		end
		self.Interface:SetAnimation("GAME_CYCLE200")
		self.State = 1
	end

    -- Handle interface:
	if self.State == 1 or self.State == 2 or self.State == 3 then
		self.Interface:AnimationStep()
		local cooldown = math.floor((self.Cooldown-GetTime())/1000)
		if self.State == 1 then 
			self.SmallNumber1:SetFrame(2)
			self.SmallNumber2:SetFrame(0)
		elseif self.State == 2 then
			self.SmallNumber1:SetFrame(math.floor((cooldown-40)/10))
			self.SmallNumber2:SetFrame((cooldown-40)%10)
        else
            self.SmallNumber1:SetFrame(math.floor(cooldown/10))
			self.SmallNumber2:SetFrame(cooldown%10)
		end 
        if self.State == 1 or self.State == 2 then
            if GetImgStr(self.SmallNumber1.Image) ~= "GAME_INTERFACE_SMALLNUMBERS" or GetImgStr(self.SmallNumber2.Image) ~= "GAME_INTERFACE_SMALLNUMBERS" then
                self.SmallNumber1:SetImage("GAME_INTERFACE_SMALLNUMBERS")
                self.SmallNumber2:SetImage("GAME_INTERFACE_SMALLNUMBERS")
            end
        else
            if GetImgStr(self.SmallNumber1.Image) ~= "CUSTOM_INTERFACE_SMALLNUMBERS" or GetImgStr(self.SmallNumber2.Image) ~= "CUSTOM_INTERFACE_SMALLNUMBERS" then
                self.SmallNumber1:SetImage("CUSTOM_INTERFACE_SMALLNUMBERS")
                self.SmallNumber2:SetImage("CUSTOM_INTERFACE_SMALLNUMBERS")
            end
        end
	end

	-- Activate:
	if self.State == 1 then
		if SpecialAttackInput() then
			self.FirstFireball = CreateObject{x=GetClaw().X, y=GetClaw().Y, z=6100, logic="CustomLogic", name="PowerOfFireShieldBall", Speed=180, Points=0, Width=80}
			self.SecondFireball = CreateObject{x=GetClaw().X, y=GetClaw().Y, z=6100, logic="CustomLogic", name="PowerOfFireShieldBall", Speed=180, Points=120, Width=80}
			self.ThirdFireball = CreateObject{x=GetClaw().X, y=GetClaw().Y, z=6100, logic="CustomLogic", name="PowerOfFireShieldBall", Speed=180, Points=240, Width=80}
			self.Cooldown = GetTime() + 60000
			self.EmptySoundDelay = GetTime() + 20000
			self.State = 2
		end
	end

	-- In work:
	if self.State == 2 then
		if GetTime() > self.Cooldown - 40000 or GetClaw().Health <= 0 then
			self.FirstFireball:Destroy()
			self.SecondFireball:Destroy()
			self.ThirdFireball:Destroy()
			self.State = 3
		end
		if GetTime() > self.FireSoundDelay then
			PlaySound("CUSTOM_FIRESHIELD")
			self.FireSoundDelay = GetTime() + 3400
		end
	end

	-- Cooldown:
	if self.State == 3 then
		if GetTime() > self.Cooldown then
			self.State = 1
		end
		if SpecialAttackInput() and GetTime() > self.EmptySoundDelay then
			PlaySound("CLAW_EMPTYMAGIC")
			self.EmptySoundDelay = GetTime() + 2000
		end
	end

end



