local SaveFilePath = "Custom/Arcana v1.2/save.txt"

local function GetStatsTable()
	return { PlayerData()._unkns[TreasureType.Skull - 1],
	        PlayerData()._unkns[TreasureType.Crown - 1], 
            PlayerData()._unkns[TreasureType.Gecko - 1],
	        PlayerData()._unkns[TreasureType.Scepter - 1], 
            PlayerData()._unkns[TreasureType.Cross - 1],
	        PlayerData()._unkns[TreasureType.Chalice - 1], 
            PlayerData()._unkns[TreasureType.Ring - 1],
	        PlayerData()._unkns[TreasureType.Goldbar - 1], 
            PlayerData()._unkns[TreasureType.Coin - 1],
	        GetClaw().Score, 
            PlayerData().PistolAmmo, 
            PlayerData().MagicAmmo, 
            PlayerData().TNTAmmo, 
	        PlayerData().Lives, 
            GetClaw().Health, 
            DetectorHook.ArtifactsOwned, 
            DetectorHook.Difficulty, 
            DetectorHook.Resolution }
end

local function SaveToFile(self, flagNo)
	self.SaveFile = io.open(SaveFilePath, "w")
	io.output(self.SaveFile)
	io.write(self.SavedFlags)
	io.write("\n")
	io.write(table.concat(self.StatsTable1, ";"))
	io.write("\n")
	io.write(table.concat(self.StatsTable2, ";"))
	io.write("\n")
	io.write(table.concat(self.StatsTable3, ";"))
	io.close(self.SaveFile)
end

local function CheatsUsed()
	return nRes(18,74) ~= 0
end

function main(self)
	
	DetectorHook = GetObject(3206)
	
	if self.State == 0 then
		self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
		-- Destroy in multiplayer:
		if GetGameType() == GameType.MultiPlayer then 
			self:Destroy()
		end
		-- Open the save file:
		self.SaveFile = io.open(SaveFilePath, "r")
		-- The save file doesn't exist:
		if self.SaveFile == nil then
			self.SaveFile = io.open(SaveFilePath, "w")
			io.output(self.SaveFile)
			io.write("0")
			io.write("\n")
			io.write("0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0")
			io.write("\n")
			io.write("0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0")
			io.write("\n")
			io.write("0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0")
			io.close(self.SaveFile)
			self.SavedFlags = 0
			self.StatsTable1 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
			self.StatsTable2 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
			self.StatsTable3 = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		else
		-- The save file exists:
			-- Read 1st line:
			self.SavedFlags = self.SaveFile:read("*l")
			-- Read 2nd line:
			local line2 = self.SaveFile:read("*l")
			self.StatsTable1 = {}
			for stat in string.gmatch(line2, "[^;]+") do
				table.insert(self.StatsTable1, tonumber(stat))
			end
			-- Read 3rd line:
			local line3 = self.SaveFile:read("*l")
			self.StatsTable2 = {}
			for stat in string.gmatch(line3, "[^;]+") do
				table.insert(self.StatsTable2, tonumber(stat))
			end
			-- Read 4th line:
			local line4 = self.SaveFile:read("*l")
			self.StatsTable3 = {}
			for stat in string.gmatch(line4, "[^;]+") do
				table.insert(self.StatsTable3, tonumber(stat))
			end
			io.close(self.SaveFile)
		end
		-- Get Super Checkpoints:
		self.GoldFlag1 = GetObject(645)
		self.GoldFlag1Saved = 0 
		local Dest1X = self.GoldFlag1.X
		local Dest1Y = self.GoldFlag1.Y
		self.GoldFlag2 = GetObject(4297)
		self.GoldFlag2Saved = 0
		local Dest2X = self.GoldFlag2.X
		local Dest2Y = self.GoldFlag2.Y	
		self.GoldFlag3 = GetObject(2671)
		self.GoldFlag3Saved = 0
		local Dest3X = self.GoldFlag3.X
		local Dest3Y = self.GoldFlag3.Y
		-- Create warps to save points:
		if AND(self.SavedFlags, 0x10) ~= 0 then
			CreateObject {x=2192, y=1500, z=0, name="SaveWarp", logic="CustomLogic", SpeedX=Dest1X, SpeedY=Dest1Y, Counter=645, Smarts = 1}
		end
		if AND(self.SavedFlags, 0x20) ~= 0 then
			CreateObject {x=2320, y=1500, z=0, name="SaveWarp", logic="CustomLogic", SpeedX=Dest2X, SpeedY=Dest2Y, Counter=4297, Smarts = 2}
		end
		if AND(self.SavedFlags, 0x40) ~= 0 then
			CreateObject {x=2448, y=1500, z=0, name="SaveWarp", logic="CustomLogic", SpeedX=Dest3X, SpeedY=Dest3Y, Counter=2671, Smarts = 3}
		end

		self.State = 1
	end
	
	if self.State == 1 then
		-- First golden checkpoint:
		if self.GoldFlag1.State == 6 and self.GoldFlag1Saved == 0 then
			if not CheatsUsed() then
				TextOut("Your game has been saved!")
				self.StatsTable1 = GetStatsTable()
				self.SavedFlags = OR(self.SavedFlags, 0x10)
				SaveToFile(self)
				self.GoldFlag1Saved = 1
			else
				TextOut("The game was not saved, because you cheated!")
				self.GoldFlag1Saved = 1
			end
			self.State = 2
		end
		-- Second golden checkpoint:
		if self.GoldFlag2.State == 6 and self.GoldFlag2Saved == 0 then
			if not CheatsUsed() then
				TextOut("Your game has been saved!")
				self.StatsTable2 = GetStatsTable()
				self.SavedFlags = OR(self.SavedFlags, 0x20)
				SaveToFile(self)
				self.GoldFlag2Saved = 1
			else
				TextOut("The game was not saved, because you cheated!")
				self.GoldFlag2Saved = 1
			end
			self.State = 2
		end
		-- Third golden checkpoint:
		if self.GoldFlag3.State == 6 and self.GoldFlag3Saved == 0 then
			if not CheatsUsed() then
				TextOut("Your game has been saved!")
				self.StatsTable3 = GetStatsTable()
				self.SavedFlags = OR(self.SavedFlags, 0x40)
				SaveToFile(self)
				self.GoldFlag3Saved = 1
			else
				TextOut("The game was not saved, because you cheated!")
				self.GoldFlag3Saved = 1
			end
			self.State = 3
		end
	end
	
	if self.State == 2 then
		self.State = 1
	end
	
	if self.State == 3 then
		self:Destroy()
	end
end
