--[[ 

Inspired by Doom's mod "My House".

Instruction:
	Pick SpeedX and SpeedY just like with normal warp.
	Direction 4 or 6 is a vertical line - Height should be defined in pixels.
	Direction 2 or 8 is a horizontal line - Width should be defined in pixels.
	Also:
	* 'Always Active' flag should be set for all objects that'll appear on the screen at the teleport's destination.
	* Teleport's destination shouldn't be close to it's location.

]]--

function SilentTeleport(dx,dy)
    if GetClaw().DrawFlags.Invert == true then -- MPFLY fix
        Teleport(dx, dy)
    else
	    GetClaw().X = dx
		GetClaw().Y = dy
    end
end

function main(self)

    local Claw = GetClaw()    
    
	if self.State == 0 then
		self.State = 1
        self.TeleportDelay = 0
		self.DrawFlags.NoDraw, self.Flags.AlwaysActive  = true, true

    -- Another init:
    elseif self.State == 1 then
        if self.Width == 0 then self.Width = 32 end
        if self.Height == 0 then self.Height = 32 end
        self.LocRect = ffi.new("Rect", {math.floor(self.X - self.Width/2), math.floor(self.Y - self.Height/2), math.floor(self.X + self.Width/2), math.floor(self.Y + self.Height/2)})
        self.State = 2

    -- Teleport part:
	elseif self.State == 2 and Claw.X > self.LocRect.Left and Claw.X < self.LocRect.Right and Claw.Y > self.LocRect.Top and Claw.Y < self.LocRect.Bottom then
        self.DestinationX = math.floor(GetClaw().X + 64*math.floor(math.floor(self.SpeedX/64) - math.floor(self.X/64)))
        self.DestinationY = math.floor(GetClaw().Y + 64*math.floor(math.floor(self.SpeedY/64) - math.floor(self.Y/64)))
        SilentTeleport(self.DestinationX, self.DestinationY)
        self.TeleportDelay = GetTime() + 20
        self.State = 3

    -- Occasionally (when Claw is in state 4) fails to work on Y-axis, repeat when that happens:
    elseif self.State == 3 and GetTime() > self.TeleportDelay then
        if GetClaw().Y > self.DestinationY + 100 or GetClaw().Y < self.DestinationY - 100 then
            SilentTeleport(Claw.X, self.DestinationY)
            self.State = 2
        else
            self.State = 2
        end
	end
end
