--[[ Instruction:
	* XMin, YMin, XMax and YMax - if Claw is inside this area then create a silent teleport...
	* TweakX and TweakY - ...at this position...
	* SpeedX and SpeedY - ...with this destination.
	* Directions 4 and 6 are a vertical teleport lines - Height should be defined in pixels.
	* Directions 2 and 8 are a horizontal teleport lines - Width should be defined in pixels.
	Also:
	* 'Always Active' flag should be set for all objects that'll appear on the screen at the teleport's destination.
	* Teleport's destination shouldn't be close to it's location.
]] 

function main(self)
	if self.State == 0 then
		self.State = 1
		self.DrawFlags.NoDraw = true
	end
	if self.State == 1 and GetClaw().Y >= self.YMin and GetClaw().Y < self.YMax and GetClaw().X > self.XMin and GetClaw().X < self.XMax then
		CreateObject{x=self.XTweak, y=self.YTweak, z=0, logic="CustomLogic", name="SilentTeleportLine", Direction=self.Direction, SpeedX=self.SpeedX, SpeedY=self.SpeedY, Width=self.Width, Height=self.Height, Smarts=self.Smarts}
		self.State = 2
		self:Destroy()
	end
end